var Cu = Components.utils;
Cu.import("resource://oneapmrecorder/ComponentLogger.jsm");
var getLogger = ComponentLoggerFactory.getLoggerFunc("RecorderBrowser");

function navigateButton(navEvent) {
    try {
        var url = document.getElementById('location-box').value;

        if (!url || url == 'about:blank') {
            alert("请输入有效网址");
            return;
        }

        document.getElementById('tab-box').hidden=false;
        var networkEvent = new OneAPMNetworkEvent();
        networkEvent.timeStamp = new Date().getTime();
        networkEvent.type = "navigate";
        networkEvent.uri = url;
        if (parent.OneAPMRecorder.session && !navEvent) {
            parent.OneAPMRecorder.session.handleNetworkEvent(networkEvent);
        }

        parent.browser.loadURI(url);
    } catch(ex) {
        var msg = ex + " filename: " + ex.fileName ;
        msg += " lineNumber: " + ex.lineNumber ;
        getLogger().error("caught exception in navigateButton : " + msg);
    }
}

function focusLocation() {
    var locationBar = document.getElementById('location-box');
    var value = locationBar.value;
    if (value){
        if (value == "about:blank") {
            locationBar.selectionStart = 0;
            locationBar.selectionEnd = locationBar.value.length;
        } else {
            locationBar.selectionStart = locationBar.value.length;
            locationBar.selectionEnd = locationBar.value.length;
        }
    }
    locationBar.focus();
}