var EXPORTED_SYMBOLS = ["ComponentLoggerFactory"];

const Cu = Components.utils;
Cu.import("resource://gre/modules/Log.jsm");
const appender = new Log.FileAppender("./log/Recorder.debug.log",new Log.BasicFormatter());
const ComponentLoggerFactory = {
    getLoggerFunc : function (moduleName) {
        var log = Log.repository.getLogger("[JSLog] " + moduleName);
        log.level = Log.Level.Trace;
        log.addAppender(appender);
        var _loggerSingleton = log;
        return function () {
            return {
                error : function errorpara() {
                    var msg = " : " ;
                    var vars = errorpara.arguments;
                    for (var i = 0; i < vars.length; i++) {
                        msg += vars[i];
                    }
                    _loggerSingleton.error(msg);
                },
                warn : function warnpara() {
                    var msg =  " : ";
                    var vars = warnpara.arguments;
                    for (var i = 0; i < vars.length; i++) {
                        msg += vars[i];
                    }
                    _loggerSingleton.warn(msg);
                },
                info : function infopara() {
                    var msg = " : ";
                    var vars = infopara.arguments;
                    for (var i = 0; i < vars.length; i++) {
                        msg += vars[i];
                    }
                    _loggerSingleton.info(msg);
                },

                debug : function debugpara() {
                    var msg = " : ";
                    var vars = debugpara.arguments;
                    for (var i = 0; i < vars.length; i++) {
                        msg += vars[i];
                    }
                    _loggerSingleton.debug(msg);
                },

                trace : function tracepara() {
                    var msg = " : ";
                    var vars = tracepara.arguments;
                    for (var i = 0; i < vars.length; i++) {
                        msg += vars[i];
                    }
                    _loggerSingleton.trace(msg);
                },
                // currently there is no fatal log, use error temporarily
                fatal : function fatalpara() {
                    var msg = " : " ;
                    var vars = fatalpara.arguments;
                    for (var i = 0; i < vars.length; i++) {
                        msg += vars[i];
                    }
                    _loggerSingleton.fatal(msg);
                },
                // TODO. following functions not used for log4plus,
                // after remove codes related with log4js, these functions can be deleted
                isTraceEnabled : function () {
                    return true
                },
                isDebugEnabled : function () {
                    return true
                },
                isInfoEnabled : function () {
                    return true
                },
                isWarnEnabled : function () {
                    return true
                },
                isErrorEnabled : function () {
                    return true
                },
                isFatalEnabled : function () {
                    return true
                },
                init : function (logMethod, logArgs) {},
                setLevel : function (level) {},
                endTransaction : function (keepLog) {},
                startTransaction : function (newLogName) {}
            };
        };
    }
};

